/*
 * Sort.h
 *
 *  Created on: 01.10.2012
 *      Author: dsinnig
 */

//Private inheritance is useful when we want to construct an object through a different object and potentially adapt it's behavior by overriding one if its private methods.
//In this case we are modifying the behavior of (base) class "Sort" (sorting in ascending order) by overriding the virtual method "inOrder" (so that sort is performed in descending order).

//Note that the same behavior can be implemented using composition and public inheritance.
// (1) Define a public subclass "CustomSort" of base class "Sort" which overrides method "inOrder".
// (2) Add a member attribute of type "CustomSort" to class "IntSet". Call the sort() method of "CustomSort" in method "sortAndPrint"

#ifndef SORT_H_
#define SORT_H_

class Sort {
public:
	Sort();
	virtual ~Sort();
	void sort(int* elements, int max);

private:
	//default behavior is sorting in ascending order
	virtual bool inOrder(int val1, int val2);
	void swap(int& val1, int&val2);
};

#endif /* SORT_H_ */
